# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_with bootstrap

%global namedversion %{version}

Name:           maven-javadoc-plugin
Version:        2.8.1
Release:        3%{?dist}
Epoch:          0
Summary:        Generate Javadocs
Group:          Development/Java
License:        ASL 2.0
URL:            http://maven.apache.org/plugins/maven-javadoc-plugin
%if 0
svn export http://svn.apache.org/repos/asf/maven/plugins/tags/maven-javadoc-plugin-2.8.1 && tar cjf maven-javadoc-plugin-2.8.1.tar.bz2 maven-javadoc-plugin-2.8.1/
%endif
Source0:        maven-javadoc-plugin-%{namedversion}.tar.bz2
Source1:        maven-javadoc-plugin-settings.xml
Source2:        maven-javadoc-plugin-jpp-depmap.xml
Patch0:         maven-javadoc-plugin-pom.patch
Patch1:         maven-javadoc-plugin-JavadocReport-doxia-sink.patch
Patch2:         maven-javadoc-plugin-FixJavadocMojoTest.patch 
Patch3:         maven-javadoc-plugin-JavadocReportTest.patch 

Obsoletes:      maven2-plugin-javadoc <= 2.0.8
Provides:       maven2-plugin-javadoc = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       apache-commons-httpclient >= 0:3.1
Requires:       apache-commons-lang >= 0:2.4
Requires:       apache-commons-logging >= 0:1.1.1
Requires:       qdox >= 0:1.9.2
Requires:       maven2 >= 0:2.0.8
Requires:       log4j >= 0:1.2.14
Requires:       maven-archiver >= 0:2.3
Requires:       maven-doxia >= 0:1.0
Requires:       maven-doxia-sitetools >= 0:1.0
Requires:       maven-reporting-api >= 0:2.0.8
Requires:       maven-shared-invoker >= 0:2.0.8
Requires:       maven-shared-toolchain >= 0:1.0
Requires:       maven-wagon >= 0:1.0
Requires:       mockito
Requires:       plexus-archiver >= 0:1.0
Requires:       plexus-container-default
Requires:       plexus-utils >= 0:1.5.8
BuildRequires:  jpackage-utils
BuildRequires:  apache-commons-httpclient >= 0:3.1
BuildRequires:  apache-commons-lang >= 0:2.4
BuildRequires:  apache-commons-logging >= 0:1.1.1
BuildRequires:  qdox >= 0:1.9.2
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-shared-invoker >= 0:2.0.8
BuildRequires:  maven-shared-toolchain >= 0:1.0
BuildRequires:  qdox
BuildRequires:  log4j >= 0:1.2.14
BuildRequires:  maven-archiver >= 0:2.3
BuildRequires:  maven-doxia >= 0:1.0
BuildRequires:  maven-doxia-sitetools >= 0:1.0
BuildRequires:  maven-reporting-api >= 0:2.0.8
BuildRequires:  maven-shared-invoker >= 0:2.0.8
BuildRequires:  maven-wagon >= 0:1.0
BuildRequires:  plexus-archiver >= 0:1.0
BuildRequires:  plexus-container-default
BuildRequires:  plexus-utils >= 0:1.5.8
BuildRequires:  junit-addons >= 0:1.4
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  mockito
BuildRequires:  maven-common-artifact-filters >= 0:1.2
BuildRequires:  maven-shared-plugin-testing-harness >= 0:1.2
BuildRequires:  jetty6-ext >= 0:6.1.19
BuildRequires:  jetty6 >= 0:6.1.19
BuildRequires:  servlet_api
BuildRequires:  maven-enforcer-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  modello-maven-plugin
%if %without bootstrap
BuildRequires:  maven2-plugin-javadoc >= %{epoch}:%{version}
%endif        
BuildRequires:  maven2
BuildRequires:  maven2-common-poms
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-shade
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Javadoc Plugin uses the Javadoc tool to generate
javadocs for the specified project.
 
%if %without bootstrap
%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p0 -b .sav2
%patch3 -p0 -b .sav3

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
export MAVEN_SETTINGS=$(pwd)/settings.xml

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.test.failure.ignore=true \
        install 
%if %without bootstrap
%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:javadoc
%else
%endif        

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}
install -p -m 644 target/maven-javadoc-plugin-%{namedversion}.jar %{buildroot}%{_javadir}/maven-javadoc-plugin-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `echo $jar| sed "s|-%{namedversion}||g"`; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-maven-javadoc-plugin.pom
%add_to_maven_depmap org.apache.maven.plugins maven-javadoc-plugin %{namedversion} JPP maven-javadoc-plugin

%if %without bootstrap
# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/maven-javadoc-plugin-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/maven-javadoc-plugin-%{namedversion}
ln -s maven-javadoc-plugin-%{namedversion} %{buildroot}%{_javadocdir}/maven-javadoc-plugin
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/maven-javadoc-plugin-%{namedversion}.jar
%{_javadir}*/maven-javadoc-plugin.jar
%{_datadir}/maven2/poms/JPP-maven-javadoc-plugin.pom
%{_mavendepmapfragdir}/%{name}

%if %without bootstrap
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/maven-javadoc-plugin-%{namedversion}
%{_javadocdir}/maven-javadoc-plugin
%endif

%changelog
* Tue May 22 2012 Ralph Apel <r.apel@r-apel.de> 2.8.1-3
- mockito is runtime dependency

* Tue May 22 2012 Ralph Apel <r.apel@r-apel.de> 2.8.1-2
- 2.8.1 as non-bootstrap

* Tue May 22 2012 Ralph Apel <r.apel@r-apel.de> 2.8.1-1
- 2.8.1 bootstrap

* Sat Oct 15 2011 David Walluck <dwalluck@redhat.com> 2.7-23
- build as non-bootstrap

* Tue Feb 15 2011 David Walluck <dwalluck@redhat.com> 2.7-22
- fix for JPackage

* Tue Feb 15 2011 David Walluck <dwalluck@redhat.com> 2.7-21
- remove qdox dependency from pom

* Tue Feb 15 2011 David Walluck <dwalluck@redhat.com> 2.7-20
- remove fix mojo (and dependency on qdox 1.9.2)

* Tue Sep 28 2010 Hui Wang <huwang@redhat.com> 2.7-19
- Adjust BRs

* Fri Sep 03 2010 Weinan Li <weli@redhat.com> 2.7-18
- Remove xbean-reflect-3.4.jar

* Fri Sep 03 2010 Weinan Li <weli@redhat.com> 2.7-17
- Fix maven-invoker version in pom.patch
- Add xbean-reflect-3.4.jar

* Wed Sep 01 2010 Weinan Li <weli@redhat.com> 2.7-16
- Remove qdox from depmap
- Remove maven-shared-invoker from depmap

* Mon Aug 30 2010 Hui Wang <huwang@redhat.com> 2.7-15
- Fix bootstrap value to 0

* Mon Aug 30 2010 Hui Wang <huwang@redhat.com> 2.7-14
- Enable javadoc 

* Mon Aug 30 2010 Hui Wang <huwang@redhat.com> 2.7-13
- Remove maven-toolchain.jar
- Add commons-codec jpp depmap
- Disable javadoc 
- Build with maven2-2.2.1

* Fri Aug 27 2010 Hui Wang <huwang@redhat.com> 2.7-12
- Enable javadoc

* Fri Aug 27 2010 Hui Wang <huwang@redhat.com> 2.7-11
- Remove JavadocReport.java.patch
- Disable javadoc temperately

* Thu Aug 26 2010 Weinan Li <weli@redhat.com> 2.7-10
- Patch our doxia from JavadocReport 

* Wed Aug 25 2010 Weinan Li <weli@redhat.com> 2.7-9
- Modify pom.xml
- Remove three sed scripts and migrate it into patch
- Patch JavadocReport.java 

* Wed Aug 25 2010 Weinan Li <weli@redhat.com> 2.7-8
- Patch out org.apache.maven.doxia.siterenderer.sink.SiteRendererSink in JavadocReport.java

* Wed Aug 25 2010 Weinan Li <weli@redhat.com> 2.7-7
- Patch JavadocReport.java to confirm the problem caused by doxia

* Tue Aug 24 2010 Weinan Li <weli@redhat.com> 2.7-6
- Change JavadocReport.java.patch

* Tue Aug 24 2010 Weinan Li <weli@redhat.com> 2.7-5
- Modify JavadocReport.java.patch

* Sat Aug 07 2010 Hui Wang <huwang@redhat.com> 2.7-4
- Change source tarball xz to bz2
- Add maven-toolchain.jar as source2 temperately until maven221 is ready
- Add JavadocReport.java.patch
- Disable javadoc temperately
 
* Sat Jul 24 2010 Alexander Kurtakov <akurtako@redhat.com> 2.7-3
- Add missing invoker requires.

* Wed Jul 21 2010 Alexander Kurtakov <akurtako@redhat.com> 2.7-2
- Add missing invoker BR.

* Wed Jul 21 2010 Alexander Kurtakov <akurtako@redhat.com> 2.7-1
- Update to 2.7.

* Fri May  7 2010 Mary Ellen Foster <mefoster at gmail.com> - 2.4-2
- Add jpackage-utils requirements
- Update requirements of javadoc subpackage

* Thu May  6 2010 Mary Ellen Foster <mefoster at gmail.com> - 2.4-1
- Initial version, based on akurtakov's initial spec
